=== debian/changelog ===
renderdoc (1.4+dfsg-1) unstable; urgency=medium

  * d/copyright: drop deleted resource.h from exclude list
  * d/patches: Rebase for 1.4
  * d/control: Update Standards-Version to 4.4.0
  * d/patches: Install python module under /usr/lib/python3/dist-packages
  * d/control: Depend on python3 for renderdoc python module
  * d/control: Depend on glslang-dev (>= 7.11.3214)
  * debian: Update debhelper to 12

 -- Jordan Justen <jordan.l.justen@intel.com>  Sun, 28 Jul 2019 18:04:57 -0700
